
#include "stm32f10x.h"
#include "math.h"
#include "DelaySysTick.h"

void InitSysTick(void)
{
	SysTick->CTRL &= ~SysTick_CTRL_TICKINT; 	// disable interrupt from systick
	SysTick->CTRL |= SysTick_CTRL_CLKSOURCE; // select fclk as clocksource
	SysTick->LOAD  = SysTick_Delay_ms;
//	SysTick->CTRL |= SysTick_CTRL_ENABLE;		// start systick
}
//

void Delay_ms(uint32_t nTime)								// utilize SysTick hardware
{ 
	SysTick->LOAD  = SysTick_Delay_ms;				// initiate start of counting
	SysTick->VAL  = 1;												// clear/reload counter
	SysTick->CTRL |= SysTick_CTRL_ENABLE;			// start systick
	SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	// clear flag
	TimingDelay = nTime;  
	while(TimingDelay>0)
	{
  	while((SysTick->CTRL & SysTick_CTRL_COUNTFLAG)==0){;};
		SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	
		TimingDelay--;
	}
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE;		// stop systick
}
//

void Delay_us(uint32_t nTime)								// utilize SysTick hardware
{ 
	SysTick->LOAD  = SysTick_Delay_us;				// initiate start of counting
	SysTick->VAL  = 1;												// initiate start of counting
	SysTick->CTRL |= SysTick_CTRL_ENABLE;			// start systick
	SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	// clear flag
	TimingDelay = nTime;  
	while(TimingDelay>0)
	{
		while((SysTick->CTRL & SysTick_CTRL_COUNTFLAG)==0){;};
		SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	
		TimingDelay--;
	}
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE;		// stop systick
}
//

void Delay_10us(uint32_t nTime)							// utilize SysTick hardware
{ 
	SysTick->LOAD  = SysTick_Delay_10us;			// initiate start of counting
	SysTick->VAL  = 1;												// clear/reload counter
	SysTick->CTRL |= SysTick_CTRL_ENABLE;			// start systick
	SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	// clear flag
//	return;
	TimingDelay = nTime;  
	while(TimingDelay>0)
	{
		while((SysTick->CTRL & SysTick_CTRL_COUNTFLAG)==0){;};
		SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	
		TimingDelay--;
	}
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE;		// stop systick
}
//

void Delay_100us(uint32_t nTime)						// utilize SysTick hardware
{ 
	SysTick->LOAD  = SysTick_Delay_100us;			// initiate start of counting
	SysTick->VAL  = 1;												// clear/reload counter
	SysTick->CTRL |= SysTick_CTRL_ENABLE;			// start systick
	SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	// clear flag
	TimingDelay = nTime;  
	while(TimingDelay>0)
	{
		while((SysTick->CTRL & SysTick_CTRL_COUNTFLAG)==0){;};
		SysTick->CTRL &=~SysTick_CTRL_COUNTFLAG;	
		TimingDelay--;
	}
	SysTick->CTRL &= ~SysTick_CTRL_ENABLE;		// stop systick
}
//




