//************************************************************************//
//
//	LCD s6d0129 
// stm32f100c6t6
//
//************************************************************************//
#include "stm32f10x.h" 
#include "core_cm3.h" // F0 core
#include "DelaySysTick.h"
#include "lcd_s6d0129.h"
#include "GPIO_macro.h"

unsigned char lcd1100_X,lcd1100_Y;//	Две глобальные переменные расположения курсора

//************************************************************************//

//	Передать данные дисплею
//	Input : cd - команда или данные, с - байт данных или команды

void lcd_s6d0129_reset(void)
{
	lcd_s6d0129_RST_RST;
	Delay_ms(100);
	lcd_s6d0129_RST_RUN;
}
//

void lcd_s6d0129_CNTrst(void)
{
	lcd_s6d0129_RS_CMD;
	Lcd_Write_Com(0x0000);
	Lcd_Write_Com(0x0000);

}
//

void lcd_s6d0129_write18bit(char RS,uint32_t DATA)
{
	lcd_s6d0129_WR_H;
	if(RS==lcd_s6d0129_CMD)
	{
		lcd_s6d0129_RS_CMD;
	}
	else
	{
		lcd_s6d0129_RS_DAT;
	}

	GPIOB->BSRR = GPIO_BSRR_BS14 	& (DATA<<(14-9));				// set DB9  (DATA.9)
	GPIOB->BRR 	= GPIO_BRR_BR14 	& (~DATA<<(14-9));			// clr DB9
	GPIOB->BSRR = GPIO_BSRR_BS13 	& (DATA<<(13-10));			// set DB10 (DATA.10)
	GPIOB->BRR 	= GPIO_BRR_BR13 	& (~DATA<<(13-10));			// clr DB10
	GPIOB->BSRR = GPIO_BSRR_BS12 	& (DATA<<(12-11));			// set DB11 (DATA.11)
	GPIOB->BRR 	= GPIO_BRR_BR12 	& (~DATA<<(12-11));			// clr DB11
	GPIOB->BSRR = GPIO_BSRR_BS11 	& (DATA>>(12-11));			// set DB12 (DATA.12)
	GPIOB->BRR  = GPIO_BRR_BR11 	& (~DATA>>(12-11));			// clr DB12
	GPIOB->BSRR = GPIO_BSRR_BS10 	& (DATA>>(13-10));			// set DB13 (DATA.13)
	GPIOB->BRR  = GPIO_BRR_BR10 	& (~DATA>>(13-10));			// clr DB13
	GPIOB->BSRR = GPIO_BSRR_BS2 	& (DATA>>(14-2));				// set DB14 (DATA.14)
	GPIOB->BRR 	= GPIO_BRR_BR2 		& (~DATA>>(14-2));			// clr DB14
	GPIOB->BSRR = GPIO_BSRR_BS1 	& (DATA>>(15-1));				// set DB15 (DATA.15)
	GPIOB->BRR 	= GPIO_BRR_BR1 		& (~DATA>>(15-1));			// clr DB15
	GPIOB->BSRR = GPIO_BSRR_BS0 	& (DATA>>(16-0));				// set DB16 (DATA.16)
	GPIOB->BRR 	= GPIO_BRR_BR0 		& (~DATA>>(16-0));			// clr DB16
	GPIOA->BSRR = GPIO_BSRR_BS7 	& (DATA>>(17-7));				// set DB17 (DATA.17)
	GPIOA->BRR 	= GPIO_BRR_BR7 		& (~DATA>>(17-7));			// clr DB17
	
	lcd_s6d0129_WR_L;
	lcd_s6d0129_WR_H;
	
	GPIOB->BSRR = GPIO_BSRR_BS14 	& (DATA<<(14-0));				// set DB9  (DATA.0)
	GPIOB->BRR 	= GPIO_BRR_BR14 	& (~DATA<<(14-0));			// clr DB9
	GPIOB->BSRR = GPIO_BSRR_BS13 	& (DATA<<(13-1));				// set DB10 (DATA.1)
	GPIOB->BRR 	= GPIO_BRR_BR13 	& (~DATA<<(13-1));			// clr DB10
	GPIOB->BSRR = GPIO_BSRR_BS12 	& (DATA<<(12-2));				// set DB11 (DATA.2)
	GPIOB->BRR 	= GPIO_BRR_BR12 	& (~DATA<<(12-2));			// clr DB11
	GPIOB->BSRR = GPIO_BSRR_BS11 	& (DATA<<(11-3));				// set DB12 (DATA.3)
	GPIOB->BRR  = GPIO_BRR_BR11 	& (~DATA<<(11-3));			// clr DB12
	GPIOB->BSRR = GPIO_BSRR_BS10 	& (DATA<<(10-4));				// set DB13 (DATA.4)
	GPIOB->BRR  = GPIO_BRR_BR10 	& (~DATA<<(10-4));			// clr DB13
	GPIOB->BSRR = GPIO_BSRR_BS2 	& (DATA>>(5-2));				// set DB14 (DATA.5)
	GPIOB->BRR 	= GPIO_BRR_BR2 		& (~DATA>>(5-2));				// clr DB14
	GPIOB->BSRR = GPIO_BSRR_BS1 	& (DATA>>(6-1));				// set DB15 (DATA.6)
	GPIOB->BRR 	= GPIO_BRR_BR1 		& (~DATA>>(6-1));				// clr DB15
	GPIOB->BSRR = GPIO_BSRR_BS0 	& (DATA>>(7-0));				// set DB16 (DATA.7)
	GPIOB->BRR 	= GPIO_BRR_BR0 		& (~DATA>>(7-0));				// clr DB16
	GPIOA->BSRR = GPIO_BSRR_BS7 	& (DATA>>(8-7));				// set DB17 (DATA.8)
	GPIOA->BRR 	= GPIO_BRR_BR7 		& (~DATA>>(8-7));				// clr DB17

	lcd_s6d0129_WR_L;
	lcd_s6d0129_WR_H;
	
	return;
	
}
//

void lcd_s6d0129_write16bit(char RS,uint16_t DATA)
{
	
	lcd_s6d0129_WR_H;
	if(RS==lcd_s6d0129_CMD)
	{
		lcd_s6d0129_RS_CMD;
	}
	else
	{
		lcd_s6d0129_RS_DAT;
	}

	GPIOB->BSRR = GPIO_BSRR_BS13 	& (DATA<<(13-8));				// set DB10 (DATA.8)
	GPIOB->BRR 	= GPIO_BRR_BR13 	& (~DATA<<(13-8));			// clr DB10
	GPIOB->BSRR = GPIO_BSRR_BS12 	& (DATA<<(12-9));				// set DB11 (DATA.9)
	GPIOB->BRR 	= GPIO_BRR_BR12 	& (~DATA<<(12-9));			// clr DB11
	GPIOB->BSRR = GPIO_BSRR_BS11 	& (DATA<<(11-10));			// set DB12 (DATA.10)
	GPIOB->BRR  = GPIO_BRR_BR11 	& (~DATA<<(11-10));			// clr DB12
	GPIOB->BSRR = GPIO_BSRR_BS10 	& (DATA>>(11-10));			// set DB13 (DATA.11)
	GPIOB->BRR  = GPIO_BRR_BR10 	& (~DATA>>(11-10));			// clr DB13
	GPIOB->BSRR = GPIO_BSRR_BS2 	& (DATA>>(12-2));				// set DB14 (DATA.12)
	GPIOB->BRR 	= GPIO_BRR_BR2 		& (~DATA>>(12-2));			// clr DB14
	GPIOB->BSRR = GPIO_BSRR_BS1 	& (DATA>>(13-1));				// set DB15 (DATA.13)
	GPIOB->BRR 	= GPIO_BRR_BR1 		& (~DATA>>(13-1));			// clr DB15
	GPIOB->BSRR = GPIO_BSRR_BS0 	& (DATA>>(14-0));				// set DB16 (DATA.14)
	GPIOB->BRR 	= GPIO_BRR_BR0 		& (~DATA>>(14-0));			// clr DB16
	GPIOA->BSRR = GPIO_BSRR_BS7 	& (DATA>>(15-7));				// set DB17 (DATA.15)
	GPIOA->BRR 	= GPIO_BRR_BR7 		& (~DATA>>(15-7));			// clr DB17
	
	//Delay_us(10);
	lcd_s6d0129_WR_L;
	//Delay_us(10);
	lcd_s6d0129_WR_H;
	//Delay_us(10);
	
	GPIOB->BSRR = GPIO_BSRR_BS13 	& (DATA<<(13-0));				// set DB10 (DATA.0)
	GPIOB->BRR 	= GPIO_BRR_BR13 	& (~DATA<<(13-0));			// clr DB10
	GPIOB->BSRR = GPIO_BSRR_BS12 	& (DATA<<(12-1));				// set DB11 (DATA.1)
	GPIOB->BRR 	= GPIO_BRR_BR12 	& (~DATA<<(12-1));			// clr DB11
	GPIOB->BSRR = GPIO_BSRR_BS11 	& (DATA<<(11-2));				// set DB12 (DATA.2)
	GPIOB->BRR  = GPIO_BRR_BR11 	& (~DATA<<(11-2));			// clr DB12
	GPIOB->BSRR = GPIO_BSRR_BS10 	& (DATA<<(10-3));				// set DB13 (DATA.3)
	GPIOB->BRR  = GPIO_BRR_BR10 	& (~DATA<<(10-3));			// clr DB13
	GPIOB->BSRR = GPIO_BSRR_BS2 	& (DATA>>(4-2));				// set DB14 (DATA.4)
	GPIOB->BRR 	= GPIO_BRR_BR2 		& (~DATA>>(4-2));				// clr DB14
	GPIOB->BSRR = GPIO_BSRR_BS1 	& (DATA>>(5-1));				// set DB15 (DATA.5)
	GPIOB->BRR 	= GPIO_BRR_BR1 		& (~DATA>>(5-1));				// clr DB15
	GPIOB->BSRR = GPIO_BSRR_BS0 	& (DATA>>(6-0));				// set DB16 (DATA.6)
	GPIOB->BRR 	= GPIO_BRR_BR0 		& (~DATA>>(6-0));				// clr DB16
	GPIOA->BSRR = GPIO_BSRR_BS7 	& (DATA>>(7-7));				// set DB17 (DATA.7)
	GPIOA->BRR 	= GPIO_BRR_BR7 		& (~DATA>>(7-7));				// clr DB17

	//Delay_us(10);
	lcd_s6d0129_WR_L;
	//Delay_us(10);
	lcd_s6d0129_WR_H;
	//Delay_us(10);
	
	return;	
	
}	
//

void Lcd_Write_Com(uint16_t DATA)	 //write 16 bit command synonim
{	
 lcd_s6d0129_write16bit(lcd_s6d0129_CMD,DATA);
}
//

void Lcd_Write_Data(uint16_t DATA) //write 16 bit data synonim
{
 lcd_s6d0129_write16bit(lcd_s6d0129_DAT,DATA);
}
//

void Lcd_Write_Com_Data(uint16_t com,uint16_t val)		// write 16 bit command then 16 bit data  synonim
{
	lcd_s6d0129_write16bit(lcd_s6d0129_CMD , com);
  lcd_s6d0129_write16bit(lcd_s6d0129_DAT , val);
}
//

void Lcd_pixel(uint16_t DATA) //write 8 bit mirror color
{
	lcd_s6d0129_RS_DAT;
	GPIOB->BSRR = GPIO_BSRR_BS13 	& (DATA<<(13-0));				// set DB10 (DATA.0)
	GPIOB->BRR 	= GPIO_BRR_BR13 	& (~DATA<<(13-0));			// clr DB10
	GPIOB->BSRR = GPIO_BSRR_BS12 	& (DATA<<(12-1));				// set DB11 (DATA.1)
	GPIOB->BRR 	= GPIO_BRR_BR12 	& (~DATA<<(12-1));			// clr DB11
	GPIOB->BSRR = GPIO_BSRR_BS11 	& (DATA<<(11-2));				// set DB12 (DATA.2)
	GPIOB->BRR  = GPIO_BRR_BR11 	& (~DATA<<(11-2));			// clr DB12
	GPIOB->BSRR = GPIO_BSRR_BS10 	& (DATA<<(10-3));				// set DB13 (DATA.3)
	GPIOB->BRR  = GPIO_BRR_BR10 	& (~DATA<<(10-3));			// clr DB13
	GPIOB->BSRR = GPIO_BSRR_BS2 	& (DATA>>(4-2));				// set DB14 (DATA.4)
	GPIOB->BRR 	= GPIO_BRR_BR2 		& (~DATA>>(4-2));				// clr DB14
	GPIOB->BSRR = GPIO_BSRR_BS1 	& (DATA>>(5-1));				// set DB15 (DATA.5)
	GPIOB->BRR 	= GPIO_BRR_BR1 		& (~DATA>>(5-1));				// clr DB15
	GPIOB->BSRR = GPIO_BSRR_BS0 	& (DATA>>(6-0));				// set DB16 (DATA.6)
	GPIOB->BRR 	= GPIO_BRR_BR0 		& (~DATA>>(6-0));				// clr DB16
	GPIOA->BSRR = GPIO_BSRR_BS7 	& (DATA>>(7-7));				// set DB17 (DATA.7)
	GPIOA->BRR 	= GPIO_BRR_BR7 		& (~DATA>>(7-7));				// clr DB17
	lcd_s6d0129_WR_L;
	lcd_s6d0129_WR_H;
	lcd_s6d0129_WR_L;
	lcd_s6d0129_WR_H;
	return;
}
//


void lcd_s6d0129_init(void)	//	Инициализация дисплея
{
	S6D0129_IM3_Off;
	S6D0129_nRD_On;
	S6D0129_nWR_On;
	Delay_ms(100);

	//************* Start Initial Sequence **********//
	
	Lcd_Write_Com_Data(0x0000,0x0001);//
	Delay_ms(6);
	Lcd_Write_Com_Data(0x0014,0x040B);//
	Lcd_Write_Com_Data(0x0013,0x0070);//
	Delay_ms(7);
	Lcd_Write_Com_Data(0x0011,0x3704);//
	Lcd_Write_Com_Data(0x0010,0x1600);//
	Delay_ms(5);
	Lcd_Write_Com_Data(0x0001,0x0827);//(0x0001,0x0927);
	Lcd_Write_Com_Data(0x0002,0x0700);//
	Lcd_Write_Com_Data(0x0003,0x1008);//(0x0003,0x0030);//(0x0003,0x1038);
	Lcd_Write_Com_Data(0x0007,0x0004);//
	Lcd_Write_Com_Data(0x0008,0x0505);
	Lcd_Write_Com_Data(0x0009,0x0000);
	Lcd_Write_Com_Data(0x000B,0x0000);
	Lcd_Write_Com_Data(0x000C,0x0000);//

	Lcd_Write_Com_Data(0x0040,0x0000);//
	Lcd_Write_Com_Data(0x0046,0xEF00);//
	Lcd_Write_Com_Data(0x0047,0x013F);//
	Lcd_Write_Com_Data(0x0048,0x0000);//
	Delay_ms(5);

	Lcd_Write_Com_Data(0x0030,0x0000);//Gamma Control 1
	Lcd_Write_Com_Data(0x0031,0x0006);//Gamma Control 2
	Lcd_Write_Com_Data(0x0032,0x0000);//Gamma Control 3
	Lcd_Write_Com_Data(0x0033,0x0000);//Gamma Control 4
	Lcd_Write_Com_Data(0x0034,0x0707);//Gamma Control 5
	Lcd_Write_Com_Data(0x0035,0x0700);//Gamma Control 6
	Lcd_Write_Com_Data(0x0036,0x0303);//Gamma Control 7
	Lcd_Write_Com_Data(0x0037,0x0007);//Gamma Control 8
	Lcd_Write_Com_Data(0x0038,0x1100);//Gamma Control 9
	Lcd_Write_Com_Data(0x0039,0x1100);//Gamma Control 10

	Lcd_Write_Com_Data(0x0007,0x0017);
	Delay_ms(5);
	
	
	
	
	
	
//	Lcd_Write_Com_Data(0x00e5, 0x8000);	
//	
//	Lcd_Write_Com_Data(0x0000,0x0001); Delay_ms(100);	

//	Lcd_Write_Com_Data(0x0011,0x2E00);  
//  Lcd_Write_Com_Data(0x0014,0x040B);
//  Lcd_Write_Com_Data(0x0010,0x1040);	Delay_ms(10);              
//  Lcd_Write_Com_Data(0x0013,0x0040);	Delay_ms(10);           
//	Lcd_Write_Com_Data(0x0013,0x0060);	Delay_ms(10);  
//	Lcd_Write_Com_Data(0x0013,0x0070);	Delay_ms(6);  
//	Lcd_Write_Com_Data(0x0011,0x3704);
//	Lcd_Write_Com_Data(0x0010,0x1600);	Delay_ms(2); 
//	Lcd_Write_Com_Data(0x0001,0x0927);  
//  Lcd_Write_Com_Data(0x0002,0x0700);            
//	Lcd_Write_Com_Data(0x0003,0x1030);		//(0x1030,0x1010)
//  Lcd_Write_Com_Data(0x0007,0x0004);           
//  Lcd_Write_Com_Data(0x0008,0x0505);           
//  Lcd_Write_Com_Data(0x0009,0x0000);
//  Lcd_Write_Com_Data(0x000B,0x0000);
//  Lcd_Write_Com_Data(0x000C,0x0000);
//               
//               
//  Lcd_Write_Com_Data(0x0040,0x0000);
//  /*	Lcd_Write_Com_Data(0x0042,0x013F);
//    	Lcd_Write_Com_Data(0x0043,0x0000);
//    	Lcd_Write_Com_Data(0x0044,0x013F);
//    	Lcd_Write_Com_Data(0x0045,0x0000);	*/
//  Lcd_Write_Com_Data(0x0046,0xEF00);
//  Lcd_Write_Com_Data(0x0047,0x013F);
//  Lcd_Write_Com_Data(0x0048,0x0000);	Delay_ms(5);
//    
//    
//  Lcd_Write_Com_Data(0x0030,0x0000);
//  Lcd_Write_Com_Data(0x0031,0x0006);
//  Lcd_Write_Com_Data(0x0032,0x0000);
//  Lcd_Write_Com_Data(0x0033,0x0000);
//  Lcd_Write_Com_Data(0x0034,0x0707);
//  Lcd_Write_Com_Data(0x0035,0x0700);
//  Lcd_Write_Com_Data(0x0036,0x0303);
//  Lcd_Write_Com_Data(0x0037,0x0007);
//  Lcd_Write_Com_Data(0x0038,0x1100);
//  Lcd_Write_Com_Data(0x0039,0x1100);                                                    
//                                   
//    
//  Lcd_Write_Com_Data(0x0007,0x0015);	Delay_ms(4);
//  Lcd_Write_Com_Data(0x0007,0x0017);	Delay_ms(4);
//    
//  Lcd_Write_Com_Data(0x0020,0x0000);	Delay_ms(10);			//Set Address... LSB 0x10 (76560)
//  Lcd_Write_Com_Data(0x0021,0x0000);	Delay_ms(10);      //Set Address... HSB 0x12B   
//	Lcd_Write_Com(0x0022);
	
	Delay_ms(100);
}
//

void char_posHV_print(int16_t ych, int16_t xch, unsigned char symbol)
{
	uint16_t x1,x2,y1,y2,iv,ih;
	if(xch >= 24 || ych >= 32 || xch < 0 || ych < 0){return;}
	x2=239-xch*10;
	x1=x2-9;
	y2=319-ych*10;
	y1=y2-4;
	Address_set(x1,y1,x2,y2);
	
	
	if(32<=symbol&&symbol<='~')
	{
		symbol=symbol-32;
	}
	else
	{
		if(192<=symbol&&symbol<=255)
		{
			symbol=symbol-97;
		}
		else
		{
			symbol=255;
		}
	}
	
	for(iv=0;iv<8;iv++)
	{
		for(ih=0;ih<5;ih++)
		{
			if((((font8V5H[symbol][ih])>>(iv))&0x01)==0){Lcd_pixel(BLACK);}
			else{Lcd_pixel(WHITE);}			
		}
	}

}
//

void char_posHV_printBIG(int16_t ych, int16_t xch, unsigned char symbol)
{
	uint16_t x1,x2,y1,y2,iv,ih;
	if(xch >= 12 || ych >= 16 || xch < 0 || ych < 0){return;}
	x2=239-xch*20;
	x1=x2-19;
	y2=319-ych*20;
	y1=y2-9;
	Address_set(x1,y1,x2,y2);

	
	if(32<=symbol&&symbol<='~')
	{
		symbol=symbol-32;
	}
	else
	{
		if(192<=symbol&&symbol<=255)
		{
			symbol=symbol-97;
		}
		else
		{
			symbol=255;
		}
	}
	
	for(iv=0;iv<16;iv++)
	{
		for(ih=0;ih<5;ih++)
		{
			if((((font8V5H[symbol][ih])>>(iv/2))&0x01)==0){Lcd_pixel(BLACK);Lcd_pixel(BLACK);}
			else{Lcd_pixel(WHITE);Lcd_pixel(WHITE);}			
		}
	}

}
//

void char_posHV_printBIGx4(int16_t ych, int16_t xch, unsigned char symbol)
{
	uint16_t x1,x2,y1,y2,iv,ih;
	if(xch >= 6 || ych >= 8 || xch < 0 || ych < 0){return;}
	x2=239-xch*40;
	x1=x2-35;
	y2=319-ych*40;
	y1=y2-19;
	Address_set(x1,y1,x2,y2);
	
	
	if(32<=symbol&&symbol<='~')
	{
		symbol=symbol-32;
	}
	else
	{
		if(192<=symbol&&symbol<=255)
		{
			symbol=symbol-97;
		}
		else
		{
			symbol=255;
		}
	}
	
	for(iv=0;iv<32;iv++)
	{
		for(ih=0;ih<5;ih++)
		{
			if((((font8V5H[symbol][ih])>>(iv/4))&0x01)==0){Lcd_pixel(BLACK);Lcd_pixel(BLACK);Lcd_pixel(BLACK);Lcd_pixel(BLACK);}
			else{Lcd_pixel(WHITE);Lcd_pixel(WHITE);Lcd_pixel(WHITE);Lcd_pixel(WHITE);}			
		}
	}

}
//

void Address_set(unsigned char x1,unsigned int y1,unsigned char x2,unsigned int y2)
{
  Lcd_Write_Com(0x0046);Lcd_Write_Data((x2<<8)|x1);   //ޡ˸X ߪʼX
	Lcd_Write_Com(0x0047);Lcd_Write_Data(y2);	  	   //ޡ˸Y
  Lcd_Write_Com(0x0048);Lcd_Write_Data(y1);   	   //ߪʼY
	Lcd_Write_Com(0x0020);Lcd_Write_Data(x2);	  //ʨ׃XظҪλ׃
  Lcd_Write_Com(0x0021);Lcd_Write_Data(y2);   //ʨ׃YظҪλ׃
  Lcd_Write_Com(0x0022);							 
}
//

void disp_snow(void)//ѩۭۨĦ
{
	unsigned char i;
	unsigned int n;
  Lcd_Write_Com_Data(0x0046,0xEF00);
  Lcd_Write_Com_Data(0x0047,0x013F);
  Lcd_Write_Com_Data(0x0048,0x0000);	
  Lcd_Write_Com(0x0022);	 
	for(n=0;n<160;n++)//**132
	{
		for(i=0;i<120;i++)
		{
			Lcd_Write_Data(0x0000);
			Lcd_Write_Data(0xffff);
		}
		for(i=0;i<120;i++)
		{
			Lcd_Write_Data(0xffff);
			Lcd_Write_Data(0x0000);
		}
	}
	return ;
}
//

void Pant(char VH,char VL)
{
	int i,j;
	Address_set(0,0,239,319);
	Lcd_Write_Com(0x0022);	 

  for(i=0;i<320;i++)
	{
	  for (j=0;j<240;j++)
	  {
      Lcd_Write_Data((VH<<8)|VL);
	  }
	}
}
//

////	Преобразование символов через таблицу символов для вывода на дисплей
////	Input : с - символ в ASCII кодировке
//unsigned char lcd1100_symbol_decode(unsigned char c)
//{
//	if(32<=c&&c<='~')
//	{
//		c=c-32;
//	}
//	else
//	{
//		if(192<=c&&c<=255)
//		{
//			c=c-97;
//		}
//		else
//		{
//			c=255;
//		}
//	}
//	return c;
//}



////	Отправка строки на дисплей
////	Input : s - строка
//void lcd1100_puts(const char *s)
//{
//	while (*s) 
//	{
//		lcd1100_putch(*s);
//		++s;
//	}
//}

//void lcd1100_puts_inv(const char *s)
//{
//	while (*s) 
//	{
//		lcd1100_putch_inv(*s);
//		++s;
//	}
//}

////	Вывод символа на дисплей х2,4,8 размера
////	Input : col - ширина, row - высота, c - символ в ASCII
////	значения ширины и высоты должны быть кратны 2: 1,2,4,8
//void lcd1100_putch_big(unsigned char col,unsigned char row,unsigned char c)
//{
//	unsigned char i,j,k,l,variable1,shift1,variable2,shift2,shift3,t_X,t_Y;
//	unsigned int sym,sym2;
//	t_X=lcd1100_X;
//	t_Y=lcd1100_Y;
//	c=lcd1100_symbol_decode(c);
//	if(c==255)
//	{
//		return;
//	}
//	lcd1100_gotoxy(lcd1100_X,lcd1100_Y);
//	variable1=0;
//	shift1=8/row;
//	variable2=1;
//	switch(row)
//	{
//		case 1: {shift2=1; shift3=1; }break;
//		case 2: {shift2=16;shift3=2; }break;
//		case 4: {shift2=4; shift3=8; }break;
//		case 8: {shift2=2; shift3=32;}break;
//	}
//	for(i=0;i<row;i++)
//	{
//		for(j=0;j<5;j++)
//		{
//			sym=0;
//			l=1;
//			for(k=variable1;k<variable1+shift1;k++)
//			{
//				sym+=(lcd1100_font[c][j]&(1<<k))*l;
//				l*=shift3;
//			}
//			sym=sym/variable2;

//			sym2=0;
//			for(k=0;k<row;k++)
//			{
//				sym2=sym2+sym;
//				sym*=2;
//			}
//			for(k=0;k<col;k++)
//			{
//				lcd1100_write(lcd1100_DATA,sym2);
//			}
//		}
//		lcd1100_gotoxy(lcd1100_X,lcd1100_Y+1);
//		variable1+=shift1;
//		variable2*=shift2;
//	}
//	lcd1100_X=t_X+col;
//	lcd1100_Y=t_Y;
//}

////	Вывод строки на дисплей х2,4,8 размера
////	Input : col - ширина, row - высота, *s - ссыла на строку
////	значения ширины и высоты должны быть кратны 2: 1,2,4,8
////void lcd1100_puts_big(unsigned char col,unsigned char row,unsigned char *s)
//void lcd1100_puts_big(unsigned char col,unsigned char row,const char *s)
//{
//	while (*s) 
//	{
//		lcd1100_putch_big(col,row,*s);
//		++s;
//	}

//}

////	Тестовое заполнение дисплея подряд идущим символами
//void lcd1100_test(void)
//{
//	unsigned char i;    
//  lcd1100_gotoxy(0,0);
//	for(i=32;i<127;i++) 
//  {
//		lcd1100_putch(i);
//	}
//	for(i=192;i<=224;i++) 
//  {
//		lcd1100_putch(i);
//	}
//}
