/*
 * M50530.c
 *
 * Created: 18.09.2015 22:22:33
 *  Author: buchin
 */ 

#include "stm32f10x.h"
#include "M50530.h"

static __IO unsigned int TimingDelayLCDM50530;

void DelayLCDM50530(unsigned int nTime)
{ 
	TimingDelayLCDM50530 = nTime;  
	while(TimingDelayLCDM50530 != 0)  
	{
		TimingDelayLCDM50530--;
	}
}

void LCDM50530_0_3_BitSend (unsigned int ddata)
{
	LCDM50530E_Set;
	
	if ((ddata & (1<<0))==(1<<0)) LCDM50530D4_Set;
	else LCDM50530D4_Clr;
	
	if ((ddata & (1<<1))==(1<<1)) LCDM50530D5_Set;
	else LCDM50530D5_Clr;
	
	if ((ddata & (1<<2))==(1<<2)) LCDM50530D6_Set;
	else LCDM50530D6_Clr;
	
	if ((ddata & (1<<3))==(1<<3)) LCDM50530D7_Set;
	else LCDM50530D7_Clr;

	DelayLCDM50530(1500);
	LCDM50530E_Clr;
	DelayLCDM50530(1500);
}

void LCDM50530_4_7_BitSend (unsigned int ddata)
{
	LCDM50530E_Set;
	
	if ((ddata & (1<<4))==(1<<4)) LCDM50530D4_Set;
	else LCDM50530D4_Clr;
	
	if ((ddata & (1<<5))==(1<<5)) LCDM50530D5_Set;
	else LCDM50530D5_Clr;
	
	if ((ddata & (1<<6))==(1<<6)) LCDM50530D6_Set;
	else LCDM50530D6_Clr;
	
	if ((ddata & (1<<7))==(1<<7)) LCDM50530D7_Set;
	else LCDM50530D7_Clr;

	DelayLCDM50530(1500);
	LCDM50530E_Clr;
	DelayLCDM50530(1500);
}

void LCDM50530Send(unsigned int ddata, unsigned int CS1, unsigned int CS2)
{
	LCDM50530RnW_Wr; // RnW = 0 write to LCD
	if(CS1==0){LCDM50530CS1_Clr;}else{LCDM50530CS1_Set;}
	if(CS2==0){LCDM50530CS2_Clr;}else{LCDM50530CS2_Set;}
	LCDM50530_4_7_BitSend(ddata);
	LCDM50530_0_3_BitSend(ddata);
}

void LCDM50530_WC(unsigned int ddata) // write cursor address of RAM
{
	LCDM50530Send(ddata, 1, 1);
}

void LCDM50530_WS(unsigned int ddata) // write display start address of RAM
{
	LCDM50530Send(ddata, 1, 0);
}

void LCDM50530_WD(unsigned int ddata) // write RAM data
{
	LCDM50530Send(ddata, 0, 1);	
}

void LCDM50530_SF(unsigned int ddata) // write function mode
{
	LCDM50530Send((0xC0|(0x3F & ddata)), 0, 0);		
}

void LCDM50530_SE(unsigned int ddata) // write entry mode
{
	LCDM50530Send((0x40|(0x3F & ddata)), 0, 0);		
}

void LCDM50530_SD(unsigned int ddata) // write display mode
{
	LCDM50530Send((0x20|(0x1F & ddata)), 0, 0);		
}

void LCDM50530_MA(unsigned int ddata) // write shift cursor/display start address
{
	LCDM50530Send((0x10|(0x0F & ddata)), 0, 0);		
}

void LCDM50530_SU(unsigned int ddata) // write underline mode
{
	LCDM50530Send((0x0C|(0x03 & ddata)), 0, 0);		
}	
void LCDM50530_WU(unsigned int ddata) // write RAM underline bit
{
	LCDM50530Send((0x08|(0x03 & ddata)), 0, 0);		
}	
void LCDM50530_SB(unsigned int ddata) // write set blinking frequency 0-3
{
	LCDM50530Send((0x04|(0x03 & ddata)), 0, 0);		
}

void LCDM50530_MH(void) 									// write cursor, display start address home
{
	LCDM50530Send(0x03, 0, 0);		
}

void LCDM50530_CH(void) 									// write clear home
{
	LCDM50530Send(0x01, 0, 0);		
}	
void LCDM50530_NOP(void) 									// No operation
{
	LCDM50530Send(0x00, 0, 0);		
}	

void LCDM50530Init(void)
{
	// configure LCD

	DelayLCDM50530(700000);
	LCDM50530_SF(LCDM50530_SF_FNT8n12 | LCDM50530_SF_DT1);
	DelayLCDM50530(70000);
	LCDM50530_SE(LCDM50530_SE_CurUDatW);
	DelayLCDM50530(70000);
	LCDM50530_SD(LCDM50530_SD_LCDON | LCDM50530_SD_CurON);
	DelayLCDM50530(70000);
	LCDM50530_WD('T');
	DelayLCDM50530(70000);
	LCDM50530_WD('e');
	DelayLCDM50530(70000);
	LCDM50530_WD('s');
	DelayLCDM50530(70000);
	LCDM50530_WD('t');
	DelayLCDM50530(70000);
	LCDM50530_WD('0');
	DelayLCDM50530(70000);
}
