/*
 * M50530.h
 *
 * Created: 18.09.2015 22:16:16
 *  Author: buchin
 */ 

#ifndef INCFILE_M50530_H_
#define INCFILE_M50530_H_

// LCD commands


#define LCDM50530_WC_Line1		(1<<6)
#define LCDM50530_WC_Line2		(2<<6)
#define LCDM50530_WC_Line3		(3<<6)
#define LCDM50530_WC_Line4   	(4<<6)

#define LCDM50530_SF_IO8n4		(1<<5)
#define LCDM50530_SF_FNT8n12	(1<<4)
#define LCDM50530_SF_DT0			(1<<2)
#define LCDM50530_SF_DT1			(1<<3)
#define LCDM50530_SF_RA0			(1<<0)
#define LCDM50530_SF_RA1			(1<<1)

#define LCDM50530_SE_CurDnnUp	(1<<5)
#define LCDM50530_SE_CurUDatW	(1<<4)
#define LCDM50530_SE_CurUDatR	(1<<3)
#define LCDM50530_SE_DSADnnUp	(1<<2)
#define LCDM50530_SE_DSAUDatW	(1<<1)
#define LCDM50530_SE_DSAUDatR	(1<<0)

#define LCDM50530_SD_LCDON		(1<<4)
#define LCDM50530_SD_CurON		(1<<3)
#define LCDM50530_SD_ULineON	(1<<2)
#define LCDM50530_SD_CurBLNK	(1<<1)
#define LCDM50530_SD_ChrBLNK	(1<<0)

#define LCDM50530_MA_ShifCur	(1<<3)
#define LCDM50530_MA_CurLeft	(1<<2)
#define LCDM50530_MA_ShifDSA	(1<<1)
#define LCDM50530_MA_DSALeft	(1<<0)

#define LCDM50530_SU_1	(1<<1)			////
#define LCDM50530_SU_0	(1<<0)			////

#define LCDM50530_WU_1	(1<<1)			////
#define LCDM50530_WU_0	(1<<0)			////

#define LCDM50530_SB_B1				(1<<1)
#define LCDM50530_SB_B0				(1<<0)


#define LCDM50530CS1_Clr 	do{GPIOA->BSRR = GPIO_BSRR_BR0;}while(0)
#define LCDM50530CS1_Set 	do{GPIOA->BSRR = GPIO_BSRR_BS0;}while(0)
#define LCDM50530CS2_Clr 	do{GPIOA->BSRR = GPIO_BSRR_BR1;}while(0)
#define LCDM50530CS2_Set 	do{GPIOA->BSRR = GPIO_BSRR_BS1;}while(0)
#define LCDM50530RnW_Rd  	do{GPIOA->BSRR = GPIO_BSRR_BS2;}while(0)
#define LCDM50530RnW_Wr  	do{GPIOA->BSRR = GPIO_BSRR_BR2;}while(0)
#define LCDM50530E_Set  	do{GPIOA->BSRR = GPIO_BSRR_BS3;}while(0)
#define LCDM50530E_Clr  	do{GPIOA->BSRR = GPIO_BSRR_BR3;}while(0)

#define LCDM50530D4_Clr  	do{GPIOA->BSRR = GPIO_BSRR_BR4;}while(0)
#define LCDM50530D4_Set  	do{GPIOA->BSRR = GPIO_BSRR_BS4;}while(0)
#define LCDM50530D5_Clr  	do{GPIOA->BSRR = GPIO_BSRR_BR5;}while(0)
#define LCDM50530D5_Set  	do{GPIOA->BSRR = GPIO_BSRR_BS5;}while(0)
#define LCDM50530D6_Clr  	do{GPIOA->BSRR = GPIO_BSRR_BR6;}while(0)
#define LCDM50530D6_Set  	do{GPIOA->BSRR = GPIO_BSRR_BS6;}while(0)
#define LCDM50530D7_Clr  	do{GPIOA->BSRR = GPIO_BSRR_BR7;}while(0)
#define LCDM50530D7_Set  	do{GPIOA->BSRR = GPIO_BSRR_BS7;}while(0)

void DelayLCDM50530 (unsigned int nTime);
void LCDM50530_0_3_BitSend (unsigned int ddata);
void LCDM50530_4_7_BitSend (unsigned int ddata);
void LCDM50530Send (unsigned int ddata, unsigned int CS1, unsigned int CS2);
void LCDM50530Init(void);
void LCDM50530_WC(unsigned int ddata); // write cursor address of RAM
void LCDM50530_WS(unsigned int ddata); // write display start address of RAM
void LCDM50530_WD(unsigned int ddata); // write RAM data
void LCDM50530_SF(unsigned int ddata); // write function mode
void LCDM50530_SE(unsigned int ddata); // write entry mode
void LCDM50530_SD(unsigned int ddata); // write display mode
void LCDM50530_MA(unsigned int ddata); // write shift cursor/display start address
void LCDM50530_SU(unsigned int ddata); // write underline mode
void LCDM50530_WU(unsigned int ddata); // write RAM underline bit
void LCDM50530_SB(unsigned int ddata); // write set blinking frequency
void LCDM50530_MH(void); // write cursor, display start address home
void LCDM50530_CH(void); // write clear home
void LCDM50530_NOP(void); 									// No operation
#endif /* INCFILE_M50530_H_ */

